# Rust Template Project for Development with Actix-Web and SeaORM

## A lot of Thanks to these projects

This project template is made of:

- Rust
- [actix-web](https://actix.rs): Async web framework for rust
- [SeaORM](https://www.sea-ql.org/SeaORM/): async ORM for integrating a Rust code base with relational databases

And I won't reach this without the help of:
- sqlx
- askama
- clap
- clap_complete
- serde
- env_logger
- log

## Project strucutre

- [src](src)
    - [main.rs](src/main.rs): entrypoint
    - [completion.rs](src/completion.rs): shell completion
    - [migrations](src/migrations): migration scripts
    - [web](src/web/): web apis
        - [urls.rs](src/web/urls.rs): routes
        - [model](src/web/model/): models generated by sea-orm-cli
        - [view.rs](src/web/view.rs): url handlers
        - [controller.rs](src/web/controller.rs): logics
- [README](README.md)
- [build](build): build tools
- [scripts](scripts): automation scripts

## Start from here

### Run the server

Simply use cargo to run the project

### Package into container

The template provides a simple [Dockerfile](build/Dockerfile) and [script](scripts/build-container.sh) to build container image.

## Development

### Define a new model

> TODO

## Roadmap

- [x] Web
- [x] ORM
- [x] Packaging
- [ ] React